/*----------------------------------------------------------------------*/
/*                                                         		*/
/* Module Name: fextract						*/
/*                                                         		*/
/* Module Description: Frame data extraction 				*/
/*                                                         		*/
/* Revision History:					   		*/
/* Rel   Date     Programmer  	Comments				*/
/* 0.1	 4Oct00   D. Sigg    	First release		   		*/
/*                                                         		*/
/* Documentation References:						*/
/*	Man Pages: framedump.html					*/
/*	References: none						*/
/*                                                         		*/
/* Author Information:							*/
/* Name          Telephone       Fax             e-mail 		*/
/* Daniel Sigg   (509) 372-8132  (509) 372-8137  sigg_d@ligo.mit.edu	*/
/*                                                         		*/
/*                                                         		*/
/*                      -------------------                             */
/*                                                         		*/
/*                             LIGO					*/
/*                                                         		*/
/*        THE LASER INTERFEROMETER GRAVITATIONAL WAVE OBSERVATORY.	*/
/*                                                         		*/
/*                     (C) The LIGO Project, 1999.			*/
/*                                                         		*/
/*                                                         		*/
/* Caltech				MIT		   		*/
/* LIGO Project MS 51-33		LIGO Project NW-17 161		*/
/* Pasadena CA 91125			Cambridge MA 01239 		*/
/*                                                         		*/
/* LIGO Hanford Observatory		LIGO Livingston Observatory	*/
/* P.O. Box 1970 S9-02			19100 LIGO Lane Rd.		*/
/* Richland WA 99352			Livingston, LA 70754		*/
/*                                                         		*/
/*----------------------------------------------------------------------*/

#ifndef _LIGO_FRAMEEXTRACT_H
#define _LIGO_FRAMEEXTRACT_H


namespace framefast {


/** @name fextract
    \begin{verbatim}
    usage: fextract [options] 'channel' 'framefile' 'outfile'
           -a : ASCII data (instead of binary float)
           -n 'num' : frame number (default 0)
    \end{verbatim}
    Extracts a data channel form a frame file.
   
    @memo Extracts channel data from frames
    @author Written March 2002 by Daniel Sigg
    @ingroup IO_framefast
    @version 1.0
 ************************************************************************/


}


#endif // _LIGO_FRAMEEXTRACT_H


