#include <iostream>
#include <fstream>

  /* F2C prototypes */

#ifndef F2C_INCLUDE
#define F2C_INCLUDE

typedef long int CLAPACK_integer;
typedef char *address;
typedef short int CLAPACK_shortint;
typedef float CLAPACK_real;
typedef double CLAPACK_doublereal;
typedef struct { CLAPACK_real r, i; } CLAPACK_complex;
typedef struct { CLAPACK_doublereal r, i; } CLAPACK_doublecomplex;
typedef long int CLAPACK_logical;
typedef short int CLAPACK_shortlogical;
typedef char CLAPACK_logical1;
typedef char CLAPACK_integer1;
typedef short ftnlen;

/* typedef long long longint; */ /* system-dependent */

#define TRUE_ (1)
#define FALSE_ (0)


/* I/O stuff */
//  Note: The following conflicts with the standard library...
//
// #define abs(x) ((x) >= 0 ? (x) : -(x))
// #define dabs(x) (CLAPACK_doublereal)abs(x)
// #define min(a,b) ((a) <= (b) ? (a) : (b))
// #define max(a,b) ((a) >= (b) ? (a) : (b))
// #define dmin(a,b) (CLAPACK_doublereal)min(a,b)
// #define dmax(a,b) (CLAPACK_doublereal)max(a,b)
//
// Replacement code
//        I have changed all occurrances of dabs to fabs in the source
//        and provide the following inline functions.
inline CLAPACK_doublereal dmin(CLAPACK_doublereal a, CLAPACK_doublereal b) {return a<=b ? a : b;}
inline CLAPACK_doublereal dmax(CLAPACK_doublereal a, CLAPACK_doublereal b) {return a>=b ? a : b;}
inline CLAPACK_integer min(CLAPACK_integer a, CLAPACK_integer b) {return a<=b ? a : b;}
inline CLAPACK_integer max(CLAPACK_integer a, CLAPACK_integer b) {return a>=b ? a : b;}

/* procedure parameter types for -A and -C++ */

#define F2C_proc_par_types 1
#ifdef __cplusplus
typedef int /* Unknown procedure type */ (*U_fp)(...);
typedef CLAPACK_shortint (*J_fp)(...);
typedef CLAPACK_integer (*I_fp)(...);
typedef CLAPACK_real (*R_fp)(...);
typedef CLAPACK_doublereal (*D_fp)(...), (*E_fp)(...);
typedef /* Complex */ void (*C_fp)(...);
typedef /* double Complex */ void (*Z_fp)(...);
typedef CLAPACK_logical (*L_fp)(...);
typedef CLAPACK_shortlogical (*K_fp)(...);
typedef /* Character */ void (*H_fp)(...);
typedef /* Subroutine */ int (*S_fp)(...);
#else
typedef int /* Unknown procedure type */ (*U_fp)();
typedef CLAPACK_shortint (*J_fp)();
typedef CLAPACK_integer (*I_fp)();
typedef CLAPACK_real (*R_fp)();
typedef CLAPACK_doublereal (*D_fp)(), (*E_fp)();
typedef /* Complex */ void (*C_fp)();
typedef /* double Complex */ void (*Z_fp)();
typedef CLAPACK_logical (*L_fp)();
typedef CLAPACK_shortlogical (*K_fp)();
typedef /* Character */ void (*H_fp)();
typedef /* Subroutine */ int (*S_fp)();
#endif
/* E_fp is for real functions when -R is not specified */
typedef void C_f;	/* complex function */
typedef void H_f;	/* character function */
typedef void Z_f;	/* double complex function */
typedef CLAPACK_doublereal E_f;	/* real function with -R not specified */

/* undef any lower-case symbols that your C compiler predefines, e.g.: */

#ifndef Skip_f2c_Undefs
#undef cray
#undef gcos
#undef mc68010
#undef mc68020
#undef mips
#undef pdp11
#undef sgi
#undef sparc
#undef sun
#undef sun2
#undef sun3
#undef sun4
#undef u370
#undef u3b
#undef u3b2
#undef u3b5
#undef unix
#undef vax
#endif
#endif

/* addition definitions needed for C++ included in clapack as f2ch.add */
/* If you are using a C++ compiler, append the following to f2c.h
   for compiling libF77 and libI77. */

#ifdef __cplusplus
extern "C" {
double c_abs(CLAPACK_complex *z);
void c_div(CLAPACK_complex *, CLAPACK_complex *, CLAPACK_complex *);
double f__cabs(double CLAPACK_real, double imag);
double r_imag(CLAPACK_complex *z);
void r_cnjg(CLAPACK_complex *r, CLAPACK_complex *z);
CLAPACK_integer s_cmp(char *, char *, ftnlen,ftnlen);
  void s_copy(char *,char *, ftnlen, ftnlen);
}
#endif

extern "C" {

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <time.h>
#include <stdarg.h>   
#include "signal.h"

  /* CLAPACK prototypes */
int cher_(char *, CLAPACK_integer *, CLAPACK_real *, CLAPACK_complex *, 
	  CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *); 
int chesv_(char *uplo, CLAPACK_integer *n, CLAPACK_integer *nrhs, CLAPACK_complex *a,
	 CLAPACK_integer *lda, CLAPACK_integer *ipiv, CLAPACK_complex *b, CLAPACK_integer *ldb, CLAPACK_complex *work,
		 CLAPACK_integer *lwork, CLAPACK_integer *info);
int chetf2_(char *uplo, CLAPACK_integer *n, CLAPACK_complex *a, CLAPACK_integer *lda,
		  CLAPACK_integer *ipiv, CLAPACK_integer *info);
int chetrf_(char *uplo, CLAPACK_integer *n, CLAPACK_complex *a, CLAPACK_integer *lda,
		  CLAPACK_integer *ipiv, CLAPACK_complex *work, CLAPACK_integer *lwork, CLAPACK_integer *info);
int chetrs_(char *uplo, CLAPACK_integer *n, CLAPACK_integer *nrhs, CLAPACK_complex *
	a, CLAPACK_integer *lda, CLAPACK_integer *ipiv, CLAPACK_complex *b, CLAPACK_integer *ldb, CLAPACK_integer *
		  info);
int clacgv_(CLAPACK_integer *n, CLAPACK_complex *x, CLAPACK_integer *incx);
int claev2_(CLAPACK_complex *a, CLAPACK_complex *b, CLAPACK_complex *c, CLAPACK_real *rt1, 
		  CLAPACK_real *rt2, CLAPACK_real *cs1, CLAPACK_complex *sn1);
int clahef_(char *uplo, CLAPACK_integer *n, CLAPACK_integer *nb, CLAPACK_integer *kb,
	 CLAPACK_complex *a, CLAPACK_integer *lda, CLAPACK_integer *ipiv, CLAPACK_complex *w, CLAPACK_integer *ldw, 
		  CLAPACK_integer *info);
int crot_(CLAPACK_integer *n, CLAPACK_complex *cx, CLAPACK_integer *incx, CLAPACK_complex *
		cy, CLAPACK_integer *incy, CLAPACK_real *c, CLAPACK_complex *s);
int slaev2_(CLAPACK_real *, CLAPACK_real *, CLAPACK_real *, CLAPACK_real *, CLAPACK_real *
	    , CLAPACK_real *, CLAPACK_real *);
CLAPACK_integer ilaenv_(CLAPACK_integer *, char *, char *, CLAPACK_integer *, CLAPACK_integer *, 
	    CLAPACK_integer *, CLAPACK_integer *, ftnlen, ftnlen);


  /* BLAS prototypes */
int cgemm_(char *, char *, CLAPACK_integer *, CLAPACK_integer *, 
	    CLAPACK_integer *, CLAPACK_complex *, CLAPACK_complex *, CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *, 
	    CLAPACK_complex *, CLAPACK_complex *, CLAPACK_integer *);
CLAPACK_logical lsame_(char *, char *);
int cgemv_(char *, CLAPACK_integer *, CLAPACK_integer *, CLAPACK_complex *
	    , CLAPACK_complex *, CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *, CLAPACK_complex *, CLAPACK_complex *, CLAPACK_integer *);
int cher_(char *, CLAPACK_integer *, CLAPACK_real *, CLAPACK_complex *, 
		CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *);
int ccopy_(CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *, 
	    CLAPACK_complex *, CLAPACK_integer *);
CLAPACK_integer icamax_(CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *);
int csscal_(CLAPACK_integer *, CLAPACK_real *, CLAPACK_complex *, CLAPACK_integer *);
int cgeru_(CLAPACK_integer *, CLAPACK_integer *, CLAPACK_complex *, 
				  CLAPACK_complex *, CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *);
int cswap_(CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *, CLAPACK_complex *, CLAPACK_integer *);   
int xerbla_(char *,  CLAPACK_integer *);






}
