#ifndef MULTILIST_HH
#define MULTILIST_HH

#include <list>
#include <string>
#include <vector>
#include <iosfwd>

class MultiList {
public:
    typedef std::vector< std::string > multi_list;

public:
  MultiList(void);
  ~MultiList(void);
  void addMulti(const char* multinm);
  void addSingle(const char* singlenm);
  bool empty(void) const;
  unsigned long size(void) const;
  std::string getList(int i);
  std::ostream& print(std::ostream& out) const;
  
private:
  /**  mFile contains the input data list name(s)
   *  @memo Input data list name.
   */
  multi_list mList;
};

//======================================  Inline methods.
inline bool
MultiList::empty(void) const {
  return mList.empty();
}

inline unsigned long
MultiList::size(void) const {
  return mList.size();
}

inline std::string
MultiList::getList(int i) {
  return mList[i];
}

#endif // MULTILIST_HH
